class Admin::UsersNewInterfaceController < ApplicationController
  
  layout "new_admin"
  before_filter :authenticate_user!
  before_filter :set_attribute, :only => [:index, :show, :new, :edit]
  
  def index
    get_tags
    get_sub_roles

    page_num = params[:page] || 1
    @users = []
    
    render case params[:at]
      when 'summary'
        @users=User.page(page_num).per(12).includes('avatar')
        "index_summary"
      when 'thumbnail'
        @users=User.page(page_num).per(36).includes('avatar')
        "index_thumbnail"
      else
        @users=User.page(page_num).per(10).includes('avatar')
        "index"
    end
  end
  
  def show
    @user = User.find(params[:id])
    @profile_data = []
    @teacher_data = []
    @student_data = []
    @staff_data = []

    @user.attribute_values.each{|att_val|
      @profile_data.push({:name => att_val.attribute_field.title,:value =>att_val[I18n.locale]}) if att_val.attribute_field.attribute.key=="profile" rescue false
    }
    
    @user.attribute_values.each{|att_val|
      @teacher_data.push({:name => att_val.attribute_field.title,:value => eval("att_val.#{att_val.key}")}) if att_val.attribute_field.role.key=="teacher"rescue false
    }

    @user.attribute_values.each{|att_val|
      @student_data.push({:name => att_val.attribute_field.title,:value =>eval("att_val.#{att_val.key}")}) if att_val.attribute_field.role.key=="student"rescue false
    }

    @user.attribute_values.each{|att_val|
      @staff_data.push({:name => att_val.attribute_field.title,:value =>eval("att_val.#{att_val.key}")}) if att_val.attribute_field.role.key=="staff_data"rescue false
    }

    # binding.pry
    # @user.attribute_values.each{|att_val|
    #   @teacher_data.push({:name => att_val.attribute_field.title,:value =>att_val[I18n.locale]})
    # }

    # @user.attribute_values.each{|att_val|
    #   @student_data.push({:name => att_val.attribute_field.title,:value =>att_val[I18n.locale]})
    # }

    # @user.attribute_values.each{|att_val|
    #   @staff_data.push({:name => att_val.attribute_field.title,:value =>att_val[I18n.locale]})
    # }

     # [ {:name=> "1",:value =>"Matt"},{:name=> "2",:value =>"Mark"},{:name=> "3",:value =>"Luke"},{:name=> "4",:value =>"John"} ]
    
    get_info_and_roles
  end
  
  def new
    @user = User.new
    get_info_and_roles
  end
  
  def create
    puts params.to_yaml
    @user = User.new(params[:user])
    if @user.save
      flash[:notice] = t('admin.create_success_user')
      redirect_to :action => :index
    else
      render :action => :new      
    end
  end
  
  def edit
    @user = User.find(params[:id])
    get_info_and_roles
  end
  
  def update
    @user = User.find(params[:id])
    
    # Update changes to the avatar
    @user.remove_avatar! if params[:file]
    @user.avatar = params[:file] if params[:file]
    
    if @user.id.to_s.eql?(session['warden.user.user.key'][1].to_s) && @user.admin != params[:user][:admin].to_i.to_b
      flash.now[:error] = t('admin.cant_revoke_self_admin')
    end
    if !flash[:error] && @user.update_attributes(params[:user])
      flash[:notice] = t('admin.update_success_user')
      redirect_to :action => :index
    else
      get_info_and_roles
      render :action => :edit
    end
  end
  
  def destroy
    if params[:id].eql?(session['warden.user.user.key'][1].to_s)
      flash[:error] = t('admin.cant_delete_self')
    else
      @user = User.find(params[:id]) 
      @user.destroy
    end
    
    redirect_to :action => :index
  end
  
  protected
  def get_tags
    @sub_role_tags = SubRoleTag.all
  end

  def get_sub_roles
    @sub_roles = SubRole.all
  end

  def get_info_and_roles
    @infos = Info.excludes('disabled' => true)
    @roles = Role.excludes('disabled' => true)
  end

  def set_attribute
    @class = 'users'
  end
  
end
